{$N+,E+}
program Test_CPU;
uses Dos;
var
  i : Byte;
  x, DelayCnt : LongInt;

procedure DelayLoop; near; assembler;
asm
@1:	sub	ax, 1
	sbb	dx, 0
	jc	@2
	cmp	bl, es:[di]
	je	@1
@2:
end;

procedure Test_Delay; assembler;
type
  LongRec = record
    Lo, Hi : Word
  end;
asm
	mov	es, Seg0040
	mov	di, $6c
	mov	bl, es:[di]
@1:	cmp	bl, es:[di]
	je	@1
	mov	bl, es:[di]
	mov	ax, -28
	cwd
	call	DelayLoop
	not	ax
	not	dx
	mov	bx, ax
	mov	ax, dx
	xor	dx, dx
	mov	cx, 55
	div	cx
	mov	DelayCnt.LongRec.Hi, ax
	mov	ax, bx
	div	cx
	mov	DelayCnt.LongRec.Lo, ax
end;

procedure Test2;
var
  j : Integer;
  Time, k : LongInt;
begin
  k:=0;
  for j:=1 to 10 do
  begin
    Time:=MemL[0:$046c]; while MemL[0:$046c]=Time do;
    Inc(Time,2); while MemL[0:$046c]<>Time do Inc(k)
  end;
  WriteLn('Test2: ',k div 10)
end;

function Test_Real : LongInt;
const N = 100000;
var
  TimeBeg, TimeEnd, i : Longint;
  Hour, Min, Sec, Sec100 : Word;
  a, b, c, d, e : Real;
begin
  b:=Pi; c:=0.9; d:=1.7; e:=0.81;
  GetTime(Hour,Min,Sec,Sec100);
  TimeBeg:=(LongInt(Hour*60+Min)*60+Sec)*100+Sec100;
  for i:=1 to N do a:=b*c/d+e-2.09;
  GetTime(Hour,Min,Sec,Sec100);
  TimeEnd:=(LongInt(Hour*60+Min)*60+Sec)*100+Sec100;
  Test_Real:=Round(N*400/(TimeEnd-TimeBeg))
end;

function Test_Extended : LongInt;
const N = 500000;
var
  TimeBeg, TimeEnd, i : LongInt;
  Hour, Min, Sec, Sec100 : Word;
  a, b, c, d, e : Extended;
begin
  b:=Pi; c:=0.9; d:=1.7; e:=0.81;
  GetTime(Hour,Min,Sec,Sec100);
  TimeBeg:=(LongInt(Hour*60+Min)*60+Sec)*100+Sec100;
  for i:=1 to N do a:=b*c/d+e-2.09;
  GetTime(Hour,Min,Sec,Sec100);
  TimeEnd:=(LongInt(Hour*60+Min)*60+Sec)*100+Sec100;
  Test_Extended:=Round(N*400/(TimeEnd-TimeBeg))
end;

begin
  if Test8087=0 then WriteLn(' ᮯ');
  x:=0;
  for i:=1 to 15 do
  begin
    Test_Delay; x:=x+DelayCnt
  end;
  WriteLn('DelayCnt ( CRT) = ',x div 15); Test2;
  WriteLn('⭮⥫쭠 ᪮':60);
  WriteLn('(᫮ 権  饩 ⮩  ᥪ㭤):':60);
  x:=0; for i:=1 to 15 do x:=x+Test_Real;
  WriteLn(' ⨯ Real = ',x div 15);
  x:=0; for i:=1 to 15 do x:=x+Test_Extended;
  WriteLn(' ⨯ Extended = ',x div 15)
end.